using System.Collections.Generic;
using Upsilon.BaseTypes;
using Upsilon.Text;

namespace Upsilon.Binder
{
    public class BoundLiteralExpression : BoundExpression
    {
        public BoundLiteralExpression(ScriptType value, TextSpan span) : base(span)
        {
            Value = value;
        }

        public override BoundKind Kind => BoundKind.BoundLiteralExpression;
        public override IEnumerable<BoundNode> GetNodeAtPosition(int characterPosition)
        {
            yield return this;
        }

        public override Type Type => Value.Type;
        public ScriptType Value { get; }
    }
}