using System.Collections.Generic;
using Upsilon.BaseTypes;
using Upsilon.Text;

namespace Upsilon.Binder
{
    public class BoundUnaryExpression : BoundExpression
    {
        public override BoundKind Kind => BoundKind.BoundUnaryExpression;
        public override IEnumerable<BoundNode> GetNodeAtPosition(int characterPosition)
        {
            if (characterPosition >= InExpression.Span.Start && characterPosition <= InExpression.Span.End)
                foreach (var boundNode in InExpression.GetNodeAtPosition(characterPosition))
                    yield return boundNode;

            yield return this;
        }

        public override Type Type { get; }

        public BoundUnaryExpression(BoundUnaryOperator op, BoundExpression inExpression, Type type, TextSpan span) : base(span)
        {
            Operator        = op;
            InExpression = inExpression;
            Type            = type;
        }

        public BoundExpression InExpression { get; }
        public BoundUnaryOperator Operator { get; }
    }
}