using System.Collections.Generic;
using System.Collections.Immutable;
using System.Linq;
using Upsilon.Text;

namespace Upsilon.Binder
{
    public class BoundBlockStatement : BoundStatement
    {
        public BoundBlockStatement(ImmutableArray<BoundStatement> statements, TextSpan span) : base(span)
        {
            Statements = statements;
        }

        public override BoundKind Kind => BoundKind.BoundBlockStatement;
        public override IEnumerable<BoundNode> GetNodeAtPosition(int characterPosition)
        {
            foreach (var statement in Statements)
            {
                if (characterPosition >= statement.Span.Start && characterPosition <= statement.Span.End)
                    foreach (var boundNode in statement.GetNodeAtPosition(characterPosition))
                        yield return boundNode;
            }
            yield return this;
        }

        public ImmutableArray<BoundStatement> Statements { get; }
    }
}