using System.Collections.Generic;
using Upsilon.Text;

namespace Upsilon.Binder
{
    public class BoundTableAssigmentStatement : BoundStatement
    {
        public BoundExpression TableIndexExpression { get; }
        public BoundExpression Value { get; }

        public BoundTableAssigmentStatement(BoundExpression tableIndexExpression, BoundExpression value,
            TextSpan span) : base(span)
        {
            TableIndexExpression = tableIndexExpression;
            Value = value;
        }

        public override BoundKind Kind => BoundKind.BoundTableAssigmentStatement;
        public override IEnumerable<BoundNode> GetNodeAtPosition(int characterPosition)
        {
            if (characterPosition >= TableIndexExpression.Span.Start && characterPosition <= TableIndexExpression.Span.End)
                foreach (var boundNode in TableIndexExpression.GetNodeAtPosition(characterPosition))
                    yield return boundNode;

            if (characterPosition >= Value.Span.Start && characterPosition <= Value.Span.End)
                foreach (var boundNode in Value.GetNodeAtPosition(characterPosition))
                    yield return boundNode;

            yield return this;

        }
    }
}