using System.Collections.Generic;
using Upsilon.Text;

namespace Upsilon.Binder
{
    public class BoundVariableAssignment : BoundStatement
    {
        public BoundVariableSymbol Variable { get; }
        public BoundExpression BoundExpression { get; }
        public bool IsLocalDefinition { get; }

        public BoundVariableAssignment(BoundVariableSymbol variable, BoundExpression boundExpression, bool isLocalDefinition,
            TextSpan span) : base(span)
        {
            Variable = variable;
            BoundExpression = boundExpression;
            IsLocalDefinition = isLocalDefinition;
        }

        public override BoundKind Kind => BoundKind.BoundAssignmentStatement;
        public override IEnumerable<BoundNode> GetNodeAtPosition(int characterPosition)
        {
            if (characterPosition >= Variable.Span.Start && characterPosition <= Variable.Span.End)
                yield return Variable;
            if (characterPosition >= BoundExpression.Span.Start && characterPosition <= BoundExpression.Span.End)
                foreach (var boundNode in BoundExpression.GetNodeAtPosition(characterPosition))
                    yield return boundNode;

            yield return this;

        }
    }
}