using System;
using System.Collections.Generic;
using Upsilon.Text;

namespace Upsilon.Binder
{
    internal class BoundWhileStatement : BoundStatement
    {
        public BoundExpression Condition { get; }
        public BoundStatement Block { get; }

        public BoundWhileStatement(BoundExpression condition, BoundStatement block, TextSpan eSpan)
        :base(eSpan)
        {
            Condition = condition;
            Block = block;
        }

        public override BoundKind Kind => BoundKind.BoundWhileStatement;
        public override IEnumerable<BoundNode> GetNodeAtPosition(int characterPosition)
        {
            if (characterPosition >= Condition.Span.Start && characterPosition <= Condition.Span.End)
                foreach (var boundNode in Condition.GetNodeAtPosition(characterPosition))
                    yield return boundNode;

            if (characterPosition >= Block.Span.Start && characterPosition <= Block.Span.End)
                foreach (var boundNode in Block.GetNodeAtPosition(characterPosition))
                    yield return boundNode;

            yield return this;
        }
    }
}