using System.Collections.Generic;
using Upsilon.BaseTypes;
using Upsilon.Binder.VariableSymbols;
using Upsilon.Text;

namespace Upsilon.Binder
{
    public class BoundVariableSymbol : BoundExpression
    {
        public BoundVariableSymbol(VariableSymbol variableSymbol, bool isCreation, TextSpan span) : base(span)
        {
            VariableSymbol = variableSymbol;
            IsCreation = isCreation;
        }

        public VariableSymbol VariableSymbol { get; }

        public bool IsCreation { get; }
        public override BoundKind Kind => BoundKind.BoundVariableSymbol;
        public override IEnumerable<BoundNode> GetNodeAtPosition(int characterPosition)
        {
            yield return this;
        }

        public override Type Type => VariableSymbol.Type;
    }
}