using System.Collections.Immutable;
using Upsilon.BaseTypes;

namespace Upsilon.Binder.VariableSymbols
{
    public abstract class FunctionVariableSymbol : VariableSymbol
    {
        public         Type                           ResultType { get; internal set; }

        public FunctionVariableSymbol(string name, bool local, Type resultType)
            : base(name, Type.Function, local)
        {
            ResultType = resultType;
        }

        public abstract (bool IsValid, string Error, BoundExpression WrongParameter) ValidateParameters(
            ImmutableArray<BoundExpression> callingParameters);
    }
}