using Upsilon.BaseTypes;
using Upsilon.BoundTypes;

namespace Upsilon.Binder.VariableSymbols
{
    public class UserDataVariableSymbol : VariableSymbol
    {
        public BoundTypeDefinition BoundTypeDefinition { get; }
        public UserDataBoundTypeDefinition Parent { get; }

        public UserDataVariableSymbol(string name, Type type) : base(name, type, true)
        {
            _type = type;
        }

        public UserDataVariableSymbol(string name, BoundTypeDefinition type, UserDataBoundTypeDefinition parent = null)
            : base(name, type.ScriptType, true)
        {
            BoundTypeDefinition = type;
            Parent = parent;
        }

        private Type _type;
        public override Type Type
        {
            get => BoundTypeDefinition?.ScriptType ?? _type;
            set => _type = Type;
        }
    }
}