using System;

namespace Upsilon.Exceptions
{
    public class ScriptRuntimeException : Exception
    {
        public string ErrorMessage { get; }
        public int    Line         { get; }
        public int    Character    { get; }
        public string ErrorLine    { get; }

        public ScriptRuntimeException(string errorMessage, int line, int character, string errorLine)
        {
            ErrorMessage = errorMessage;
            Line         = line;
            Character    = character;
            ErrorLine    = errorLine;
        }

        public override string ToString()
        {
            return $"{ErrorMessage} at ({Line}, {Character})\n{ErrorLine}";
        }

        public override string Message => ToString();
    }
}