using System;

namespace Upsilon.StandardLibraries
{
    [AttributeUsage(AttributeTargets.Method, AllowMultiple = true, Inherited = true)]
    public class ScriptFunctionAttribute : Attribute
    {
        public ScriptFunctionAttribute(string name, string comment = null,
            bool directScriptManipulation = false, bool passScriptReference = false, bool passScopeReference = false)
        {
            Name = name;
            Comment = comment;
            DirectScriptManipulation = directScriptManipulation;
            PassScriptReference = passScriptReference;
            PassScopeReference = passScopeReference;
        }

        public string Name { get; }
        public string Comment { get; }
        public bool DirectScriptManipulation { get; }
        public bool PassScriptReference { get; }
        public bool PassScopeReference { get; }
    }
}